import * as React from 'react';
import type { Meta } from '@storybook/react';
import { LinkButton as Component, LinkButtonProps } from '.';
import { Button } from '@tesseract-design/web-base';

const meta: Meta<typeof Component> = {
	component: Component,
	argTypes: {
		variant: {
			control: { type: 'select' },
			options: Button.AVAILABLE_VARIANTS,
		},
		size: {
			control: { type: 'select' },
			options: Button.AVAILABLE_SIZES,
		},
		subtext: {
			control: { type: 'text' },
		},
		badge: {
			control: { type: 'text' },
		},
		icon: {
			control: { type: 'text' },
		},
		children: {
			control: { type: 'text' },
		},
		href: {
			table: {
				disable: true,
			},
		},
		component: {
			table: {
				disable: true,
			},
		},
		onClick: {
			table: {
				disable: true,
			},
			action: 'clicked',
		},
	},
	args: {
		...(Component.defaultProps ?? {}),
		children: Component.displayName,
	},
};

export const LinkButton = ({ onClick, ...args }: Omit<LinkButtonProps, 'ref'>) => (
	<Component
		{...args}
		href="#"
		onClick={(e) => {
			e.preventDefault();
			onClick?.(e);
		}}
	/>
);

export default meta;
